//+------------------------------------------------------------------+
//|                                      PriceChannelSkalper.mq4 |
//|                      Copyright  2009, ForexMum. |
//|                                       http://www.forexmumsblog/ |
//+------------------------------------------------------------------+
#property copyright "ForexMum"
#property link      "http://www.forexmumsblog.com"
#property indicator_minimum -100
#property indicator_maximum 0
#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

extern double       TakeProfit=10.0;
extern double       StopLoss=20.0;
extern bool         UseHourTrade  = true;         
extern int          StartHour1 = 20,
                    EndHour1= 24,
                    StartHour2=2,
                    EndHour2  = 4;                
extern bool         EachTickMode = True;
extern double       Lots=0.01;
extern int          OpenOrders=1;
extern int          MagicNumber=123;
extern bool         UseTrailingStop=true;
extern double       TrailingStop = 0.0;
extern bool         MM=true; //money management
extern double       PercentRisk=5; //risk in percentage
extern bool         CloseOnOpposite = true;

double Balance=0.0;
double sLoss;
int ticket;
int openSells;
int openBuys;
datetime timeprev=0;
int BarCount;
int Current;
bool TickCheck = False;
string Signal;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;

   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
	//----
	//----
	return(0);
}
int start() {
   int Order = SIGNAL_NONE;
   
   
   if (EachTickMode && Bars != BarCount) TickCheck = False;
   int Total = OrdersTotal();
   Order = SIGNAL_NONE;


		   double ChnlUp15= iCustom(NULL,15,"Price Channel",20,0,0,0);
		   double ChnlDwn15= iCustom(NULL,15,"Price Channel",20,0,1,0);		   
		   double ChnlUp0= iCustom(NULL,0,"Price Channel",14,0,0,0);
		   double ChnlDwn0= iCustom(NULL,0,"Price Channel",14,0,1,0);
		   double ChnlUp60= iCustom(NULL,60,"Price Channel",20,0,0,0);
		   double ChnlDwn60= iCustom(NULL,60,"Price Channel",20,0,1,0);
		   double WPR = iWPR(NULL,0,14,0);
		   double WPR1 = iWPR(NULL,0,14,1);
		   double WPR2 = iWPR(NULL,0,14,2);
		   double MA=iMA(NULL,0,60,0,MODE_SMMA,PRICE_MEDIAN,1);
         double  up=iCustom(NULL,0,"Slope Direction Line",2,3,0,0,0);
         double down=iCustom(NULL,0,"Slope Direction Line",2,3,0,1,0);
         double  up15=iCustom(NULL,15,"Slope Direction Line",2,3,0,0,0);
         double down15=iCustom(NULL,15,"Slope Direction Line",2,3,0,1,0);  
		   int orderOpenBar = iBarShift(NULL, 0, OrderOpenTime(), true);

         
// expert money management
      if(MM){if(PercentRisk<0.1||PercentRisk>100){Comment("Invalid Risk Value.");return(0);}
      else{Lots=MathFloor((AccountFreeMargin()*AccountLeverage()*PercentRisk*Point*100)/(Ask*MarketInfo(Symbol(),MODE_LOTSIZE)*MarketInfo(Symbol(),MODE_MINLOT)))*MarketInfo(Symbol(),MODE_MINLOT);}}
      if(MM==false){Lots=Lots;}
      
      if(CloseOnOpposite && orderOpenBar>1) {
      if (iHigh(NULL,0,0)==ChnlUp0) {
		CloseAllLongs();
		}
      if (iLow(NULL,0,0)==ChnlDwn0) {
		CloseAllShorts();
		}
		}
		if(CloseOnOpposite && orderOpenBar>3) {
      if (MathAbs(WPR)<10) {
		CloseAllLongs();
		}
      if (MathAbs(WPR)>90) {
		CloseAllShorts();
		}
		}
		
		
//----------------------- TIME FILTER
   if (UseHourTrade)
   {
      if(!(Hour()>=StartHour1 && Hour()<=EndHour1))
      {
         Comment("Non-Trading Hours!");
         return(0);
      }
   }
//Close if trend ends
      
		CheckTrailingStop();
		int orders = OrdersTotal();
		openSells = 0;
		openBuys = 0;
		int i;
      for(i=0;i<OrdersTotal();i++){
         if(OrderSelect(i, SELECT_BY_POS)) {
            if (OrderType() == OP_BUY) {
               openBuys++;
            } else {
               openSells++;
            }
         }
      }

		if((Hour()>=StartHour1 && Hour()<=EndHour1) || (Hour()>=StartHour2 && Hour()<=EndHour2))
      {
         if(Low[0]<=ChnlDwn0 || Low[1] <= ChnlDwn0 && MathAbs(WPR)>90 && up != EMPTY_VALUE){
		     	   if (openBuys < OpenOrders) {
		         if (StopLoss != 0) {
                   sLoss = Ask-StopLoss*Point;
               } else {
                  sLoss = 0;
               }
                  ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,sLoss,Ask+TakeProfit*Point,"PCSkalper",MagicNumber,0,Green);
			         if (UseTrailingStop==true) setTrailingStop();
			         Sleep (1000000);
			      }
			   }
			if (High[0]>=ChnlUp0 || High[1] >= ChnlUp0 && MathAbs(WPR)<10 && down != EMPTY_VALUE ) {
			  	   if (openSells < OpenOrders) {
			      if (StopLoss != 0) {
                  sLoss = Bid+StopLoss*Point;
               } else {
                  sLoss = 0;
		         }
		         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,sLoss,Bid-TakeProfit*Point,"PCSkalper",MagicNumber,0,Red);
		         if (UseTrailingStop==True) setTrailingStop();

		      }
		    }
        }
	return(0);
}

//Close all tickets
int CloseAllLongs()
      {
         for(int i=0;i<OrdersTotal();i++)
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber && OrderType()==OP_BUY)
         {
         OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, White );
         }
      }
   return(0);
}

int CloseAllShorts()
{
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber && OrderType()==OP_SELL)
      {
         OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, White );
      }
   }
  
   return(0);
}

int CheckTrailingStop()

      {
      for(int i=0;i<OrdersTotal();i++)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false || UseTrailingStop==false)        break;
      
      if(OrderSymbol()!=Symbol()) continue;
   
      if(OrderType() == OP_BUY)
         {
         if(((Bid - OrderOpenPrice()) > (Point * TrailingStop)) && (OrderStopLoss() < (Bid - Point * TrailingStop)))
            OrderModify(
                        OrderTicket(),
                        OrderOpenPrice(),
                        Bid - Point * TrailingStop,
                        OrderTakeProfit(),
                        0,
                        GreenYellow);
         }
      
      if(OrderType() == OP_SELL)
         {
         if(((OrderOpenPrice() - Ask) > (Point * TrailingStop)) && (OrderStopLoss() > (Ask + Point * TrailingStop)))
            OrderModify(
                        OrderTicket(),
                        OrderOpenPrice(),
                        Ask + Point * TrailingStop,
                        OrderTakeProfit(),
                        0,
                        Red);
         }    
      }
return(0);
      }
      
   
      int setTrailingStop()
   {
         for(int i=0;i<OrdersTotal();i++)
      {
  if(TrailingStop>0)
    {
     OrderSelect(i,SELECT_BY_TICKET);
     
     if(Bid-OrderOpenPrice()>Point*TrailingStop)
       {
        if(OrderStopLoss()<Bid-Point*TrailingStop)
          {
           OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Blue);
           return(0);
          }
       }
     }
   }
    return(0);
}

